package com.ippon.error.domain;

public class MissingMandatoryValueException extends MyAppException {

  protected MissingMandatoryValueException(MyAppExceptionBuilder builder) {
    super(builder);
  }

  private static MyAppExceptionBuilder builder(MyAppMessage myAppMessage, String fieldName, String message) {
    return MyAppException.builder(myAppMessage).status(ErrorStatus.INTERNAL_SERVER_ERROR).argument("field", fieldName).message(message);
  }

  private static String defaultMessage(String fieldName) {
    return "The field \"" + fieldName + "\" is mandatory and wasn't set";
  }

  public static MissingMandatoryValueException forNullValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_NULL, fieldName, defaultMessage(fieldName) + " (null)")
    );
  }

  public static MissingMandatoryValueException forBlankValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_BLANK, fieldName, defaultMessage(fieldName) + " (blank)")
    );
  }
}
